package linkate

import java.util.EmptyStackException;

public final class StackLinkato<E>
{
	private NodoDoppio<E> head;
	int count;

	public StackLinkato<E>()
	{
		head = null;
		count = 0;
	}

	public boolean isEmpty()
	{
		return count == 0;
		//return head == null;
	}

	public E peek()
	{
		if(isEmpty())
		{
			throw new EmptyStackException("Il vuoto cosmico...");
		}
		return head.getValue();
	}

	public E pop()
	{
		E retval = peek();

		// questo e' maniacale
		head.value = null;

		//questo, insieme a quello sotto, e' rilevante
		NodoDoppio<E> tmp = head;

		//questo e' essenziale
		head = head.next;

		//questo, insieme a quello sopra, e' rilevante
		tmp.next = null;

		count--;
		return retval;
	}

	public int size()
	{
		return count;
	}

	public E push(E item)
	{
		NodoDoppio<E> nodo = new NodoDoppio<E>(item);

		nodo.next = head;
		head = nodo;

		count++;
		return item;
	}

	public int search(Object o)
	{
		int i;
		NodoDoppio<E> nodo;
		//a proposito di maniaci...
		//for(i = 1, nodo = head; nodo!=null;i++,nodo = nodo.next)

		i = 1;
		nodo = head;
		while(nodo != null)
		{
			if(o == null)
			{
				if(nodo.getValue() == null)
				{
					return i;
				}
			}
			else
			{
				if(o.equals(nodo.getValue()))
				{
					return i;
				}
			}

			//nuova iterazione
			i++;
			nodo = nodo.next;
		}
		return -1;
	}

	public String toString()
	{
		String retval = "[";
		NodoDoppio<E> tmp = head;
		if(tmp != null)
		{
			retval = retval.concat(tmp.toString());
			tmp = tmp.next;
		}
		while(tmp != null)
		{
			retval = retval.concat(", " + tmp.toString());
			tmp = tmp.next;
		}
		retval = retval.concat("]");
		return retval;
	}
}
