package radiazioni;

import java.util.*;
import java.io.*;

public class LeggiMisure
{
	static final double threshold = 100.0;
	static final int sizeX = 10;
	static final int sizeY = 5;

	public static void main(String[] argv) throws Exception
	{
		Misura[][] misure = null;
		misure = new Misura[sizeX][sizeY];
		/* non mi serve un coso triangolare
		for(int i = 0; i<100;i++)
		{
			misure[i] = new Misura[sizeY-i];
		}
		*/
		if(misure[1][1] == null)
		{
			System.out.println("Alla locazione 1,1 non c'e' null");
		}
		String nomeFile = "data.txt";
		double threshold = 100;
		if(argv.length > 0)
		{
			nomeFile = argv[0];
		}

		if(argv.length > 1)
		{
			threshold = Double.parseDouble(argv[1]);
		}

		Scanner sc = new Scanner(new File(nomeFile));
		int numPosizioni = 0;

		while(sc.hasNextLine())
		{
			int x = Integer.parseInt(sc.nextLine());
			//se potessi assumere il file ben formato, mi potrei risparmiare il controllo
			if(!sc.hasNextLine())
			{
				System.err.println("File malformato");
				break;
			}
			int y = Integer.parseInt(sc.nextLine());
			if(misure[x][y] == null)
			{
				misure[x][y] = new Misura();
				numPosizioni++;
			}

			misure[x][y].leggiValore(sc);
		}

		System.out.println("Ho trovato dati per " + numPosizioni + " posizioni diverse");

		for(int x = 0;x<sizeX;x++)
		{
			for(int y = 0;y<sizeY;y++)
			{
				if(misure[x][y] == null)
				{
					System.out.println("Non ho misure per la posizione [" + x + "][" + y + "]");
				}
				else
				{
					System.out.println("misure per la posizione [" + x + "][" + y + "]");
					System.out.println(misure[x][y].toString());
				}
			}
		}

		int xmin = -1;
		int ymin = -1;
		double minRad = Double.MAX_VALUE;
		for(int x = 0;x<sizeX;x++)
		{
			for(int y = 0;y<sizeY;y++)
			{
				if(misure[x][y] == null)
				{
					System.out.println("Non ho misure per la posizione [" + x + "][" + y + "]");
				}
				else
				{
					System.out.print("media annuale per la posizione [" + x + "][" + y + "]: ");
					double tmpVal = misure[x][y].mediaSuAnno();
					if(tmpVal < minRad)
					{
						minRad = tmpVal;
						xmin = x;
						ymin = y;
					}
					System.out.println(tmpVal);
				}
			}
		}

		for(int x = 0;x<sizeX;x++)
		{
			for(int y = 0;y<sizeY;y++)
			{
				if(misure[x][y] == null)
				{
					System.out.println("Non ho misure per la posizione [" + x + "][" + y + "]");
				}
				else
				{
					System.out.print("media mensile per la posizione [" + x + "][" + y + "]: ");
					for(int z = 0;z<12;z++)
					{
						System.out.print(misure[x][y].mediaSuMese(z) + "; ");
					}
					System.out.println();
				}
			}
		}

		System.out.println("La posizione piu' sicura e' [" + xmin + "][" + ymin + "] con un valore medio di radiazione di " + minRad);

		for(int x = 0;x<sizeX;x++)
		{
			for(int y = 0;y<sizeY;y++)
			{
				if(misure[x][y] == null)
				{
					System.out.println("Non ho misure per la posizione [" + x + "][" + y + "]");
				}
				else
				{
					System.out.print("la posizione [" + x + "][" + y + "]: ");
					if(misure[x][y].isLethal(threshold))
					{
						System.out.println("non e' sicura");
					}
					else
					{
						System.out.println("e' sicura");
					}
				}
			}
		}
	}
}
